Package: pkgbuild
Title: Find Tools Needed to Build R Packages
Version: 1.4.6
Authors@R: c(
    person("Hadley", "Wickham", role = "aut"),
    person("Jim", "Hester", role = "aut"),
    person("Gábor", "Csárdi", , "csardi.gabor@gmail.com", role = c("aut", "cre")),
    person("Posit Software, PBC", role = c("cph", "fnd"))
  )
Description: Provides functions used to build R packages. Locates
    compilers needed to build R packages on various platforms and ensures
    the PATH is configured appropriately so R can use them.
License: MIT + file LICENSE
URL: https://github.com/r-lib/pkgbuild, https://pkgbuild.r-lib.org
BugReports: https://github.com/r-lib/pkgbuild/issues
Depends: R (>= 3.5)
Imports: callr (>= 3.2.0), cli (>= 3.4.0), desc, processx, R6
Suggests: covr, cpp11, knitr, Rcpp, rmarkdown, testthat (>= 3.2.0),
        withr (>= 2.3.0)
Config/Needs/website: tidyverse/tidytemplate
Config/testthat/edition: 3
Encoding: UTF-8
RoxygenNote: 7.3.2
NeedsCompilation: no
Packaged: 2025-01-16 17:45:57 UTC; gaborcsardi
Author: Hadley Wickham [aut],
  Jim Hester [aut],
  Gábor Csárdi [aut, cre],
  Posit Software, PBC [cph, fnd]
Maintainer: Gábor Csárdi <csardi.gabor@gmail.com>
Repository: CRAN
Date/Publication: 2025-01-16 19:00:02 UTC
Built: R 4.5.2; ; 2026-04-22 03:54:56 UTC; unix

Package: pkgbuild
Title: Find Tools Needed to Build R Packages
Version: 1.0.0
Authors@R: c(
    person("Hadley", "Wickham", role = "aut"),
    person("Jim", "Hester", , "james.hester@rstudio.com", role = c("aut", "cre")),
    person("RStudio", role = "cph")
  )
Description: Provides functions used to build R packages. Locates compilers
  needed to build R packages on various platforms and ensures the PATH is
  configured appropriately so R can use them.
Imports: callr (>= 2.0.0), crayon, desc, R6, rprojroot, withr (>=
        2.1.2)
Suggests: Rcpp, testthat, covr
License: GPL-3
Encoding: UTF-8
LazyData: true
RoxygenNote: 6.0.1
URL: https://github.com/r-pkgs/pkgbuild
BugReports: https://github.com/r-pkgs/pkgbuild/issues
Depends: R (>= 3.1)
NeedsCompilation: no
Packaged: 2018-06-27 14:22:02 UTC; jhester
Author: Hadley Wickham [aut],
  Jim Hester [aut, cre],
  RStudio [cph]
Maintainer: Jim Hester <james.hester@rstudio.com>
Repository: CRAN
Date/Publication: 2018-06-27 15:19:12 UTC
Built: R 3.4.1; ; 2018-09-20 20:49:36 UTC; windows

test_that("style", {
  withr::local_options(cli.num_colors = 256)
  expect_snapshot(
    cat(style(
      ok = "OK", "\n",
      note = "NOTE", "\n",
      warn = "WARN", "\n",
      err = "ERROR", "\n",
      pale = "Not important", "\n",
      timing = "[1m]", "\n"
    ))
  )
})

test_that("has_rtools finds rtools", {
  skip_if_not(is_windows() && !is.null(scan_path_for_rtools()))

  # Rtools path can be looked up by the PATH
  without_cache({
    expect_true(has_rtools())
    expect_true(!is.null(scan_path_for_rtools()))
  })

  withr::with_path(Sys.getenv("R_HOME"), action = "replace", {
    expect_equal(scan_path_for_rtools(), NULL)
  })

  skip_if_not(!is.null(scan_registry_for_rtools()))

  # Rtools path can be looked up from the registery
  expect_true(!is.null(scan_registry_for_rtools()))
  without_cache(
    withr::with_path(Sys.getenv("R_HOME"), action = "replace", {
      has_rtools()
      expect_true(all(rtools_path() != ""))
    })
  )
})

test_that("rtools_needed works", {
  skip_if_not(is_windows())

  # Test only frozen versions
  expect_equal(rtools_needed("3.6.3"), "Rtools 3.5")
  expect_equal(rtools_needed("2.9"), "Rtools 3.0")
  expect_equal(rtools_needed("0.0.0"), "the appropriate version of Rtools")
})

test_that("withr_with_makevars", {
  split_lines <- function(x) strsplit(x, "\n\r?")[[1]]

  orig <- split_lines(callr::rcmd("config", "CFLAGS")$stdout)
  new <- withr_with_makevars(
    new = c(CFLAGS = "-DFOO"),
    split_lines(callr::rcmd("config", "CFLAGS")$stdout)
  )
  expect_equal(new, paste(orig, "-DFOO"))

  # with our own custom Makevars file
  tmp <- tempfile()
  on.exit(unlink(tmp), add = TRUE)
  writeLines(c(
    "CFLAGS=-DTHIS",
    "CXXFLAGS+=-DTHAT"
  ), tmp)

  orig <- split_lines(callr::rcmd("config", "CFLAGS")$stdout)
  new <- withr_with_makevars(
    new = c(CFLAGS = "-DFOO"),
    path = tmp,
    split_lines(callr::rcmd("config", "CFLAGS")$stdout)
  )
  expect_equal(new, "-DTHIS -DFOO")

  orig <- split_lines(callr::rcmd("config", "CXXFLAGS")$stdout)
  new <- withr_with_makevars(
    new = c(CXXFLAGS = "-DFOO"),
    path = tmp,
    split_lines(callr::rcmd("config", "CXXFLAGS")$stdout)
  )
  expect_equal(new, paste(orig, "-DTHAT -DFOO"))
})

test_that("can compile a DLL and clean up afterwards", {
  expect_error(compile_dll("testWithSrc", quiet = TRUE, register_routines = FALSE), NA)

  clean_dll("testWithSrc")
  expect_equal(dir("testWithSrc/src"), "add1.c")
})

test_that("is_zip_file", {
  expect_true(is_zip_file(file.path("fixtures", "xxx.zip")))
  expect_false(is_zip_file(file.path("fixtures", "xxx.gz")))
  expect_false(is_zip_file(file.path("fixtures", "xxx.tar.gz")))
})

test_that("is_gz_file", {
  expect_false(is_gz_file(file.path("fixtures", "xxx.zip")))
  expect_true(is_gz_file(file.path("fixtures", "xxx.gz")))
  expect_true(is_gz_file(file.path("fixtures", "xxx.tar.gz")))
})

test_that("is_tar_gz_file", {
  expect_false(is_tar_gz_file(file.path("fixtures", "xxx.zip")))
  expect_false(is_tar_gz_file(file.path("fixtures", "xxx.gz")))
  expect_true(is_tar_gz_file(file.path("fixtures", "xxx.tar.gz")))
})

test_that("pkg_has_src", {
  expect_false(pkg_has_src(file.path("fixtures", "testDummy_0.1.tar.gz")))
  expect_true(pkg_has_src(file.path("fixtures", "testWithSrc_0.1.tar.gz")))
})

test_that("pkg_has_src on non-package files", {
  expect_error(pkg_has_src(file.path("fixtures", "xxx.zip")))
  expect_error(pkg_has_src(file.path("fixtures", "xxx.tar.gz")))
})

describe("has_compiler", {
  withr::local_options(pkgbuild.has_compiler = NULL)
  testthat::local_reproducible_output()
  it("succeeds if a compiler exists", {
    skip_if(is_windows() && !has_rtools())
    without_cache({
      without_compiler({
        expect_false(has_compiler())
        expect_error(check_compiler(), "Failed to compile C code")
      })
      cache_reset()
      expect_true(has_compiler())
      expect_true(check_compiler())
    })
  })

  it("returns the value of the has_compiler option", {
    skip_if(is_windows() && !has_rtools())
    without_cache({
      without_compiler({
        withr::with_options(
          c(pkgbuild.has_compiler = TRUE),
          {
            expect_true(has_compiler())
            expect_error(check_compiler(), NA)
          }
        )
      })
      cache_reset()
      withr::with_options(
        c(pkgbuild.has_compiler = FALSE),
        {
          expect_false(has_compiler())
          expect_error(check_compiler(), "Failed to compile C code")
        }
      )
      withr::with_options(
        list(pkgbuild.has_compiler = 1:2),
        expect_snapshot(
          error = TRUE,
          has_compiler()
        )
      )
    })
  })
})

test_that("should_stop_for_warnings", {
  withr::local_options(pkg.build_stop_for_warnings = NULL)
  withr::local_envvar(PKG_BUILD_STOP_FOR_WARNINGS = NA_character_)
  expect_false(should_stop_for_warnings())

  withr::local_options(pkg.build_stop_for_warnings = FALSE)
  withr::local_envvar(PKG_BUILD_STOP_FOR_WARNINGS = "true")
  expect_false(should_stop_for_warnings())

  withr::local_options(pkg.build_stop_for_warnings = TRUE)
  withr::local_envvar(PKG_BUILD_STOP_FOR_WARNINGS = "false")
  expect_true(should_stop_for_warnings())

  withr::local_options(pkg.build_stop_for_warnings = NULL)
  withr::local_envvar(PKG_BUILD_STOP_FOR_WARNINGS = "true")
  expect_true(should_stop_for_warnings())

  withr::local_options(pkg.build_stop_for_warnings = NULL)
  withr::local_envvar(PKG_BUILD_STOP_FOR_WARNINGS = "false")
  expect_false(should_stop_for_warnings())

  withr::local_options(pkg.build_stop_for_warnings = 1:10)
  withr::local_envvar(PKG_BUILD_STOP_FOR_WARNINGS = "false")
  expect_error(should_stop_for_warnings(), "option must be")

  withr::local_options(pkg.build_stop_for_warnings = NULL)
  withr::local_envvar(PKG_BUILD_STOP_FOR_WARNINGS = "foobar")
  expect_error(should_stop_for_warnings(), "environment variable must be")
})

test_that("isFALSE", {
  pos <- list(FALSE, structure(FALSE, class = "foo"))
  neg <- list(1, c(FALSE, TRUE), NA, list(FALSE))
  for (p in pos) expect_true(isFALSE(p), info = p)
  for (n in neg) expect_false(isFALSE(n), info = n)
})

test_that("should_add_compiler_flags", {
  # should not be called if option is set
  local_mocked_bindings(makevars_user = function() stop("dont"))

  # options is TRUE
  withr::local_options(pkg.build_extra_flags = TRUE)
  expect_true(should_add_compiler_flags())

  # options is FALSE
  withr::local_options(pkg.build_extra_flags = FALSE)
  expect_false(should_add_compiler_flags())

  # depends on whether Makevars exists
  withr::local_options(pkg.build_extra_flags = "missing")
  local_mocked_bindings(makevars_user = function() character())
  expect_true(should_add_compiler_flags())
  local_mocked_bindings(makevars_user = function() "foobar")
  withr::local_options(pkg.build_extra_flags = "missing")
  expect_false(should_add_compiler_flags())

  local_mocked_bindings(makevars_user = function() stop("dont"))
  withr::local_options(pkg.build_extra_flags = NULL)

  # env var true
  withr::local_envvar(PKG_BUILD_EXTRA_FLAGS = "true")
  expect_true(should_add_compiler_flags())

  # env var false
  withr::local_envvar(PKG_BUILD_EXTRA_FLAGS = "false")
  expect_false(should_add_compiler_flags())

  # depends on whether Makevars exists
  withr::local_envvar(PKG_BUILD_EXTRA_FLAGS = "missing")
  local_mocked_bindings(makevars_user = function() character())
  expect_true(should_add_compiler_flags())
  local_mocked_bindings(makevars_user = function() "foobar")
  expect_false(should_add_compiler_flags())

  # no option or env var, then TRUE
  local_mocked_bindings(makevars_user = function() stop("dont"))
  withr::local_options(pkg.build_extra_flags = NULL)
  withr::local_envvar(PKG_BUILD_EXTRA_FLAGS = NA_character_)
  expect_true(should_add_compiler_flags())
})

test_that("should_add_compiler_flags errors", {
  # invalid option type
  withr::local_options(pkg.build_extra_flags = 1:10)
  expect_snapshot(error = TRUE, should_add_compiler_flags())

  # invalid option value
  withr::local_options(pkg.build_extra_flags = "foobar")
  expect_snapshot(error = TRUE, should_add_compiler_flags())

  # invalid env var value
  withr::local_options(pkg.build_extra_flags = NULL)
  withr::local_envvar(PKG_BUILD_EXTRA_FLAGS = "foo")
  expect_snapshot(error = TRUE, should_add_compiler_flags())
})

test_that("has_compiler_colored_diagnostics", {
  local_mocked_bindings(cache_exists = function(...) stop("nope"))

  withr::local_envvar(PKG_BUILD_COLOR_DIAGNOSTICS = "true")
  expect_true(has_compiler_colored_diagnostics())

  withr::local_envvar(PKG_BUILD_COLOR_DIAGNOSTICS = "false")
  expect_false(has_compiler_colored_diagnostics())

  withr::local_envvar(PKG_BUILD_COLOR_DIAGNOSTICS = NA_character_)
  expect_error(has_compiler_colored_diagnostics(), "nope")
})

# style

    Code
      cat(style(ok = "OK", "\n", note = "NOTE", "\n", warn = "WARN", "\n", err = "ERROR",
        "\n", pale = "Not important", "\n", timing = "[1m]", "\n"))
    Output
      [32mOK[39m
      [38;5;214mNOTE[39m
      [1m[38;5;214mWARN[39m[22m
      [31mERROR[39m
      [38;5;247mNot important[39m
      [36m[1m][39m

# warnings can be turned into errors

    Code
      build(file.path(src, "testDummy"), dest_path = dest, quiet = TRUE)
    Message
      ! Stopping as requested for a warning during `R CMD build`.
      ! The full output is printed below.
      * checking for file '<file>' ... OK
      * preparing 'testDummy':
      * checking DESCRIPTION meta-information ... OK
      * checking for LF line-endings in source and make files and shell scripts
      * checking for empty or unneeded directories
        NB: this package now depends on R (>= 3.5.0)
        WARNING: Added dependency on R >= 3.5.0 because serialized objects in
        serialize/load version 3 cannot be read in older versions of R.
        File(s) containing such objects:
          'testDummy/inst/testthat-problems.rds'
      * building 'testDummy_0.1.tar.gz'
      
    Condition
      Error in `force()`:
      ! converted from `R CMD build` warning.
